//==============================================================
// HISTORIQUE:
// 
//     Date    - Description
// 
//  27/11/2013 - Reprise existant, mutation vers XC8
// 
//==============================================================



#include "app_clock.h"


#define APP_CLOCK_PERCLK_US		10000


#undef APP_CLOCK_OUT_TIMEBASE		// a activer si on veut avoir la "vue" de la base de temps de 1ms

#ifdef APP_CLOCK_OUT_TIMEBASE
	#define APP_CLOCK_OUT_TIMEBASE_PIN_LAT		LATAbits.LATA6
	#define APP_CLOCK_OUT_TIMEBASE_PIN_TRIS		TRISAbits.TRISA6
	#define APP_CLOCK_OUT_TIMEBASE_PIN_SPECIAL	ANSELAbits.ANSA6= 0
#endif

volatile uint16	APP_CLOCK_ms_timebase;

	
//-----------------------------------------------------------------------
//      a call dans l'IT
//-----------------------------------------------------------------------
void APP_Clock_interrupt (void ){
	HWI_timer_reload ( APP_CLOCK_TMR_CHAN );
	APP_CLOCK_ms_timebase++;
#ifdef APP_CLOCK_OUT_TIMEBASE
	APP_CLOCK_OUT_TIMEBASE_PIN_SPECIAL;
	APP_CLOCK_OUT_TIMEBASE_PIN_TRIS = 0;
	APP_CLOCK_OUT_TIMEBASE_PIN_LAT = ~APP_CLOCK_OUT_TIMEBASE_PIN_LAT;
#endif
}

//-----------------------------------------------------------------------
//      
//-----------------------------------------------------------------------
uint16 APP_Clock_GetTime ( void ){
    uint16  l_temp;		//temporaire pour prendre la valeur
    HWI_ATOMIC_START;
    l_temp = APP_CLOCK_ms_timebase;
    HWI_ATOMIC_STOP;
    return l_temp;
}


//-----------------------------------------------------------------------
//      
//-----------------------------------------------------------------------
APP_CLOCK_TIME_TYPE APP_CLOCK_MES_DELTA_TIME_MS ( APP_CLOCK_TIME_TYPE li_val){
	static uint16 l_retour;		// valeur de calcul
	HWI_ATOMIC_START;
	l_retour = APP_CLOCK_GET_TIME_MS;
	l_retour = l_retour - li_val;
        HWI_ATOMIC_STOP;
	return l_retour;
}


//-----------------------------------------------------------------------
//      
//-----------------------------------------------------------------------
void APP_Clock_init ( void ){
		
	APP_CLOCK_ms_timebase = 0;
	
	// configurer le timer et les interuptions
	HWI_timer_cfg ( APP_CLOCK_TMR_CHAN, APP_CLOCK_PERCLK_US );
	HWI_timer_reload ( APP_CLOCK_TMR_CHAN );
	HWI_timer_enable ( APP_CLOCK_TMR_CHAN );

	
	// spcifique interruptions
	APP_CLOCK_TRM_INT_FLAG = 0;
	APP_CLOCK_TRM_INT_EN = 1;
	

	#ifdef APP_CLOCK_OUT_TIMEBASE
	APP_CLOCK_OUT_TIMEBASE_PIN_LAT = 0;
	APP_CLOCK_OUT_TIMEBASE_PIN_TRIS = 0;
	APP_CLOCK_OUT_TIMEBASE_PIN_SPECIAL;
	#endif

}

//-----------------------------------------------------------------------
//      
//-----------------------------------------------------------------------
void APP_Clock_stop ( void ){
	HWI_timer_disable ( APP_CLOCK_TMR_CHAN );

}


