
#include "hwi.h"
#include "boutonsq.h"

#define BTN_APPUI               0
#define APPUI_LONG_TEMPO        10
#define APPUI_SHORT_TEMPO       2

BTN_STR     btn_0;
BTN_STR     btn_1;
BTN_STR     btn_2;
BTN_STR     btn_3;

enum{
    BTN_ETAT_IDLE,
    BTN_ETAT_APPUI_LONG,
};

// the listener should read ordre and then put it back to none : li_Ptr_str->ordre = CMD_APPUI_NONE;

//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void gere_btn (BTN_STR *li_Ptr_str){
    switch ( li_Ptr_str->etat ){
        default :
            li_Ptr_str->etat = BTN_ETAT_IDLE;
            break;
        case BTN_ETAT_IDLE:
            if ( li_Ptr_str->sw_val == BTN_APPUI ){
                if ( li_Ptr_str->u8_cpt++ >= APPUI_LONG_TEMPO ){
                    li_Ptr_str->etat = BTN_ETAT_APPUI_LONG;
                    li_Ptr_str->ordre = CMD_APPUI_LONG;
                }
            }else{
                if ( li_Ptr_str->u8_cpt >= APPUI_SHORT_TEMPO ){
                    li_Ptr_str->ordre = CMD_APPUI_SHORT;
                }
                li_Ptr_str->u8_cpt = 0;
            }
            break;

        case BTN_ETAT_APPUI_LONG:
            if ( li_Ptr_str->sw_val != BTN_APPUI ){
                li_Ptr_str->etat = BTN_ETAT_IDLE;
                li_Ptr_str->u8_cpt = 0;
                li_Ptr_str->ordre = CMD_APPUI_RELACHE;
                //li_Ptr_str->ordre = CMD_APPUI_NONE;
            }else{
                li_Ptr_str->ordre = CMD_APPUI_LONG;
            }
            break;
    }
	if ( CMD_APPUI_NONE != li_Ptr_str->ordre ){
		li_Ptr_str->u8_Changed = 1;
	}
}

//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void gestion_btn_init ( BTN_STR *l_PtrBtn ){
    l_PtrBtn->etat = BTN_ETAT_IDLE;
    l_PtrBtn->ordre = CMD_APPUI_NONE;
    l_PtrBtn->sw_val = 0;
    l_PtrBtn->u8_Changed = 0;
    l_PtrBtn->u8_cpt = 0;
}
void gestion_boutons_init ( void ){
    gestion_btn_init( &btn_0 );
    gestion_btn_init( &btn_1 );
    gestion_btn_init( &btn_2 );
    gestion_btn_init( &btn_3 );
}


//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void gestion_boutons ( void ){
    
    uint8 l_u8_port = PORTB;
    
    l_u8_port = l_u8_port & 0xF0;
    
    
    if ( (l_u8_port & MASK_BTN_0) != BTN_APPUI ){
        btn_0.sw_val = 1;
    }else{
        btn_0.sw_val = 0;
    }
    gere_btn ( &btn_0 );
    

    if ( (l_u8_port & MASK_BTN_1) != BTN_APPUI ){
        btn_1.sw_val = 1;
    }else{
        btn_1.sw_val = 0;
    }
    gere_btn ( &btn_1 );
    
    
    if ( (l_u8_port & MASK_BTN_2) != BTN_APPUI ){
        btn_2.sw_val = 1;
    }else{
        btn_2.sw_val = 0;
    }
    gere_btn ( &btn_2 );
    
    
    
    if ( (l_u8_port & MASK_BTN_3) != BTN_APPUI ){
        btn_3.sw_val = 1;
    }else{
        btn_3.sw_val = 0;
    }
    gere_btn ( &btn_3 );
    
}




