//   ==============================================================
//   | HISTORIQUE:                                                |
//   |                                                            |
//   |     Date    - Description                                  |
//   |                                                            |
//   |  27/11/2013 - Reprise existant, mutation vers XC8          |
//   |                                                            |
//   ==============================================================

#ifndef HWI_H
#define HWI_H

#pragma warning disable 752
#pragma warning disable 520






//#define PIC18F4520
#define PIC18F452



#ifdef PIC18F452
    // CONFIG1H
    #pragma config OSC = HSPLL      // Oscillator Selection bits (HS oscillator with PLL enabled/Clock frequency = (4 x FOSC))
    #pragma config OSCS = OFF       // Oscillator System Clock Switch Enable bit (Oscillator system clock switch option is disabled (main oscillator is source))

    // CONFIG2L
    #pragma config PWRT = ON       // Power-up Timer Enable bit (PWRT disabled)
    #pragma config BOR = OFF         // Brown-out Reset Enable bit (Brown-out Reset enabled)
    #pragma config BORV = 20        // Brown-out Reset Voltage bits (VBOR set to 2.0V)

    // CONFIG2H
    #pragma config WDT = OFF         // Watchdog Timer Enable bit (WDT disabled (control is placed on the SWDTEN bit))
    #pragma config WDTPS = 128      // Watchdog Timer Postscale Select bits (1:128)

    // CONFIG3H
    #pragma config CCP2MUX = OFF     // CCP2 Mux bit -> vers RB3

    // CONFIG4L
    #pragma config STVR = ON        // Stack Full/Underflow Reset Enable bit (Stack Full/Underflow will cause RESET)
    #pragma config LVP = OFF         // Low Voltage ICSP Enable bit (Low Voltage ICSP enabled)




    // CONFIG5L
    #ifndef ENABLE_CODE_PROTECTION_FLASH
    #pragma config CP0 = OFF        // Code Protection bit (Block 0 (000200-001FFFh) not code protected)
    #pragma config CP1 = OFF        // Code Protection bit (Block 1 (002000-003FFFh) not code protected)
    #pragma config CP2 = OFF        // Code Protection bit (Block 2 (004000-005FFFh) not code protected)
    #pragma config CP3 = OFF        // Code Protection bit (Block 3 (006000-007FFFh) not code protected)
    #else
    #pragma config CP0 = ON         // Code Protection bit (Block 0 (000200-001FFFh) protected)
    #pragma config CP1 = ON         // Code Protection bit (Block 1 (002000-003FFFh) protected)
    #pragma config CP2 = ON         // Code Protection bit (Block 2 (004000-005FFFh) protected)
    #pragma config CP3 = ON         // Code Protection bit (Block 3 (006000-007FFFh) protected)
    #endif



    // CONFIG5H
    #pragma config CPB = OFF        // Boot Block Code Protection bit (Boot Block (000000-0001FFh) not code protected)
    #ifndef ENABLE_CODE_PROTECTION_EEPROM
    #pragma config CPD = OFF        // Data EEPROM Code Protection bit 
    #else
    #pragma config CPD = ON        // Data EEPROM Code Protection bit 
    #endif


    // CONFIG6L
    #ifndef ENABLE_CODE_PROTECTION_FLASH
    #pragma config WRT0 = OFF       // Write Protection bit (Block 0 (000200-001FFFh) not write protected)
    #pragma config WRT1 = OFF       // Write Protection bit (Block 1 (002000-003FFFh) not write protected)
    #pragma config WRT2 = OFF       // Write Protection bit (Block 2 (004000-005FFFh) not write protected)
    #pragma config WRT3 = OFF       // Write Protection bit (Block 3 (006000-007FFFh) not write protected)
    #else
    #pragma config WRT0 = ON
    #pragma config WRT1 = ON
    #pragma config WRT2 = ON
    #pragma config WRT3 = ON
    #endif


    // CONFIG6H
    #ifndef ENABLE_CODE_PROTECTION_FLASH
    #pragma config WRTC = OFF       // Configuration Register Write Protection bit (Configuration registers (300000-3000FFh) not write protected)
    #pragma config WRTB = OFF       // Boot Block Write Protection bit (Boot Block (000000-0001FFh) not write protected)
    #else
    #pragma config WRTC = ON
    #pragma config WRTB = ON
    #endif
    #pragma config WRTD = OFF       // Data EEPROM Write Protection bit (Data EEPROM not write protected)




    // CONFIG7L
    #pragma config EBTR0 = OFF      // Table Read Protection bit (Block 0 (000200-001FFFh) not protected from Table Reads executed in other blocks)
    #pragma config EBTR1 = OFF      // Table Read Protection bit (Block 1 (002000-003FFFh) not protected from Table Reads executed in other blocks)
    #pragma config EBTR2 = OFF      // Table Read Protection bit (Block 2 (004000-005FFFh) not protected from Table Reads executed in other blocks)
    #pragma config EBTR3 = OFF      // Table Read Protection bit (Block 3 (006000-007FFFh) not protected from Table Reads executed in other blocks)




    // CONFIG7H
    #pragma config EBTRB = OFF      // Boot Block Table Read Protection bit (Boot Block (000000-0001FFh) not protected from Table Reads executed in other blocks)

#endif


#ifdef PIC18F4520
// CONFIG1H
#pragma config OSC = HS      // Oscillator Selection bits (HS oscillator, PLL enabled (Clock Frequency = 4 x FOSC1))
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable bit (Fail-Safe Clock Monitor disabled)
#pragma config IESO = OFF       // Internal/External Oscillator Switchover bit (Oscillator Switchover mode disabled)

// CONFIG2L
#pragma config PWRT = OFF       // Power-up Timer Enable bit (PWRT disabled)
#pragma config BOREN = SBORDIS  // Brown-out Reset Enable bits (Brown-out Reset enabled in hardware only (SBOREN is disabled))
#pragma config BORV = 3         // Brown Out Reset Voltage bits (Minimum setting)

// CONFIG2H
#pragma config WDT = ON         // Watchdog Timer Enable bit (WDT enabled)
#pragma config WDTPS = 32768    // Watchdog Timer Postscale Select bits (1:32768)

// CONFIG3H
#pragma config CCP2MX = PORTC   // CCP2 MUX bit (CCP2 input/output is multiplexed with RC1)
#pragma config PBADEN = OFF      // PORTB A/D Enable bit (PORTB<4:0> pins are configured as analog input channels on Reset)
#pragma config LPT1OSC = OFF    // Low-Power Timer1 Oscillator Enable bit (Timer1 configured for higher power operation)
#pragma config MCLRE = ON       // MCLR Pin Enable bit (MCLR pin enabled; RE3 input pin disabled)

// CONFIG4L
#pragma config STVREN = ON      // Stack Full/Underflow Reset Enable bit (Stack full/underflow will cause Reset)
#pragma config LVP = ON         // Single-Supply ICSP Enable bit (Single-Supply ICSP enabled)
#pragma config XINST = OFF      // Extended Instruction Set Enable bit (Instruction set extension and Indexed Addressing mode disabled (Legacy mode))

// CONFIG5L
#pragma config CP0 = OFF        // Code Protection bit (Block 0 (000800-001FFFh) not code-protected)
#pragma config CP1 = OFF        // Code Protection bit (Block 1 (002000-003FFFh) not code-protected)
#pragma config CP2 = OFF        // Code Protection bit (Block 2 (004000-005FFFh) not code-protected)
#pragma config CP3 = OFF        // Code Protection bit (Block 3 (006000-007FFFh) not code-protected)

// CONFIG5H
#pragma config CPB = OFF        // Boot Block Code Protection bit (Boot block (000000-0007FFh) not code-protected)
#pragma config CPD = OFF        // Data EEPROM Code Protection bit (Data EEPROM not code-protected)

// CONFIG6L
#pragma config WRT0 = OFF       // Write Protection bit (Block 0 (000800-001FFFh) not write-protected)
#pragma config WRT1 = OFF       // Write Protection bit (Block 1 (002000-003FFFh) not write-protected)
#pragma config WRT2 = OFF       // Write Protection bit (Block 2 (004000-005FFFh) not write-protected)
#pragma config WRT3 = OFF       // Write Protection bit (Block 3 (006000-007FFFh) not write-protected)

// CONFIG6H
#pragma config WRTC = OFF       // Configuration Register Write Protection bit (Configuration registers (300000-3000FFh) not write-protected)
#pragma config WRTB = OFF       // Boot Block Write Protection bit (Boot block (000000-0007FFh) not write-protected)
#pragma config WRTD = OFF       // Data EEPROM Write Protection bit (Data EEPROM not write-protected)

// CONFIG7L
#pragma config EBTR0 = OFF      // Table Read Protection bit (Block 0 (000800-001FFFh) not protected from table reads executed in other blocks)
#pragma config EBTR1 = OFF      // Table Read Protection bit (Block 1 (002000-003FFFh) not protected from table reads executed in other blocks)
#pragma config EBTR2 = OFF      // Table Read Protection bit (Block 2 (004000-005FFFh) not protected from table reads executed in other blocks)
#pragma config EBTR3 = OFF      // Table Read Protection bit (Block 3 (006000-007FFFh) not protected from table reads executed in other blocks)

// CONFIG7H
#pragma config EBTRB = OFF      // Boot Block Table Read Protection bit (Boot block (000000-0007FFh) not protected from table reads executed in other blocks)
#endif






    //==============================================================
    //     FICHIERS A EN-TETE
    //==============================================================


    #include "hwi_machine.h"
    #include "hwi_hard_defs.h"
    #include "hwi_timers_methods.h"
    #include "hwi_eeprom_methods.h"
    //#include "hwi_interrupts_methods.h"



    //==============================================================
    //   DEFINITIONS
    //==============================================================
    #define HWI_ERROR	1
    #define HWI_OK		0
    //#define OSC_TEMPS_CYCLE_NS	(uint32)(200)		//Tcy=20Mhz sans pll
    #define OSC_TEMPS_CYCLE_NS	(uint32)(100)		//Tcy=20Mhz sans pll





#endif
