//   ==============================================================
//   | HISTORIQUE:                                                |
//   |                                                            |
//   |     Date    - Description                                  |
//   |                                                            |
//   |  27/11/2013 - Reprise existant, mutation vers XC8          |
//   |                                                            |
//   ==============================================================





#ifndef HWI_MACHINE
#define HWI_MACHINE

    #include <xc.h>




    typedef unsigned char           uint8;
    typedef signed char             int8;
    typedef unsigned int            uint16;
    typedef signed int              int16;
//    typedef unsigned short long     uint24;
 //   typedef signed short long       int24;
    typedef signed long             int32;
    typedef unsigned long           uint32;
    typedef float                   F24;
    typedef float                   float24;

    #define sint8   int8
    #define sint16  int16
    #define sint32  int32 
    
    
    #define UINT16_MAX				(65535)
    #define sint16_MAX              ( 32767)
    #define sint16_MIN              (-32768)
    #define UINT8_MAX               (255)
	#define float24_MIN				(float24)(0.0001)
	#define UINT8_MAX_HEX			(0xff)
	#define UINT16_MAX_HEX			(0xffff)

    #define HWI_EN_IT_HIGH          INTCONbits.GIEH = 1
    #define HWI_EN_IT_LOW           INTCONbits.GIEL = 1
    #define HWI_EN_IT               HWI_EN_IT_HIGH; HWI_EN_IT_LOW

    #define HWI_DIS_IT_HIGH         INTCONbits.GIEH = 0
    #define HWI_DIS_IT_LOW          INTCONbits.GIEL = 0
    #define HWI_DIS_IT              HWI_DIS_IT_HIGH; HWI_DIS_IT_LOW


    #define HWI_ATOMIC_STOP         HWI_EN_IT
    #define HWI_ATOMIC_START		HWI_DIS_IT

	#define	HWI_PIN_HIGH			1
	#define	HWI_PIN_LOW				0
	
#endif
