//   ==============================================================
//   | HISTORIQUE:                                                |
//   |                                                            |
//   |     Date    - Description                                  |
//   |                                                            |
//   |  27/11/2013 - Reprise existant, mutation vers XC8          |
//   |                                                            |
//   ==============================================================
#ifndef HWI_TIMER_CFG_FILE
#define HWI_TIMER_CFG_FILE




//==============================================================
//   DEFINITIONS
//==============================================================
#define HWI_TIMERS_MAX_PRESCALE_NB		(uint8)8
#define HWI_TIMER_MAX_COUNT_16_BITS		(uint32)(65535)
#define HWI_TIMER_MAX_COUNT_8_BITS		(uint32)(255)
#define HWI_TIMER_MARGE_COUNT			(uint32)(1)
#define HWI_INTERRUPT_RESPONSE_TIME_US	(uint32) 49
	
	

//==============================================================
//   TYPEDEFS ET STRUCTURES
//==============================================================
// definition d'un prescaler pour le timer
typedef struct {
	uint16		diviseur;								// diviseur et 
	uint8		reg_value;								// valeur registre associe
}HWI_Timer_prescaler_type;

typedef enum{
	HWI_TIMER_8_BITS,
	HWI_TIMER_16_BITS,
	HWI_TIMER_32_BITS
}HWI_Timer_type;	

//contient la configuration pour le fonctionnement des timers
typedef struct {
	HWI_Timer_type				tmr_type;				// type de timer en 8, 16 ou 32 bits
	HWI_Timer_prescaler_type 	*prescalers;			// ptr vers struct contenant les diffrente prescalers
	uint8						*ptr_reg_TCON;			// registre de configuration
	uint8						prescaler_mask;			// emplacement des bits pour le prescaler
	uint8						*ptr_reg_val_L;			// registre pour la valeur du timer bits poids faible
	uint8						*ptr_reg_val_H;			// registre pour la valeur du timer bits poids fort
	uint8						on_val;					// cfg annexe pour l'activation, |on_val en activation, &=~on_val sinon
}HWI_Timer_cfg_type;

// parametres issus de la configuration a stocker en RAM !
typedef struct {
	uint16						param_temps;			// stocke le parametre du temps lorsque le timer est configur
	uint8						param_prescaler_val;	// stocke la valeur du prescaler calcul	
}HWI_Timer_ram_param;

//==============================================================
//   VARIABLES EXPORTEES 
//==============================================================
			
	

#endif
