
#include <xc.h>

#define HWI_IT_TMR1IF           dimmer_it_handler
#define HWI_IT_TMR0IF           APP_Clock_interrupt
#define HWI_IT_INT0IF_FCT       dimmer_SignalZeroCross

extern void HWI_IT_TMR1IF ( void );
extern void HWI_IT_TMR0IF ( void );
extern void HWI_IT_INT0IF_FCT ( void );

void __interrupt(high_priority) HWI_high_priority_int ( void )
{


	if ( 1 == PIR1bits.TMR1IF)	{ 
		PIR1bits.TMR1IF=0;
        #ifdef HWI_IT_TMR1IF
            HWI_IT_TMR1IF ();
        #endif
	}
	if ( 1 == INTCONbits.TMR0IF )
	{
		INTCONbits.TMR0IF = 0;
        #ifdef HWI_IT_TMR0IF
            HWI_IT_TMR0IF ();
        #endif
	}
	

    if ( 1 == PIR2bits.TMR3IF)  { 
        PIR2bits.TMR3IF = 0;
        #ifdef HWI_IT_TMR3IF
            HWI_IT_TMR3IF ();
        #endif
    }
    
    if ( 1 == INTCONbits.INT0F ){
        INTCONbits.INT0F = 0;
        #ifdef HWI_IT_INT0IF_FCT
            HWI_IT_INT0IF_FCT ();
        #endif
    }
    if ( 1 == INTCONbits.INT0IF ){
        INTCONbits.INT0IF = 0;
        #ifdef HWI_IT_INT0IF_FCT
            HWI_IT_INT0IF_FCT ();
        #endif
    }
    
	// problme de l'oscillateur principal, on reset !
	if ( (PIR2 & 0x80) != 0)
	{
		Reset ();
		while(1);
	}
    
}




