/*
 * File:   main.c
 * Author: user
 *
 * Created on 17 septembre 2020, 11:35
 */


#include <xc.h>
#include "dimmer.h"   
#include "hwi.h"
#include "app_clock.h"
#include "boutonsq.h"

void gestion_dimmer ( void );


APP_CLOCK_TIME_TYPE             G_time_;
APP_CLOCK_TIME_TYPE             G_time_ChkBtn;




//----------------------------------------------------------------------------
//
//
//----------------------------------------------------------------------------
typedef struct{
    DIMMER   dim_0;
    DIMMER   dim_1;
    DIMMER   dim_2;
    DIMMER   dim_3;
}STR_SAVED_CFG;
STR_SAVED_CFG       g_str_cfg;
void save_config_eeprom (){
    g_str_cfg.dim_0 = dimmer_chan0;
    g_str_cfg.dim_1 = dimmer_chan1;
    g_str_cfg.dim_2 = dimmer_chan2;
    g_str_cfg.dim_3 = dimmer_chan3;
    
    HWI_write_string_eeprom( 0, (uint8*) &g_str_cfg, sizeof(STR_SAVED_CFG) );
}
void recall_config_eeprom (){
    HWI_read_string_eeprom( 0, (uint8*) &g_str_cfg, sizeof(STR_SAVED_CFG) );
    dimmer_chan0 = g_str_cfg.dim_0;
    dimmer_chan1 = g_str_cfg.dim_1;
    dimmer_chan2 = g_str_cfg.dim_2;
    dimmer_chan3 = g_str_cfg.dim_3;
}

//----------------------------------------------------------------------------
//
//
//----------------------------------------------------------------------------
#define DELAY_INACTIVE_TO_SAVE_S        30
void CheckButonsInactifs(){
    static uint16 l_InactifCpt = 0;
    
    
    if ( l_InactifCpt < DELAY_INACTIVE_TO_SAVE_S ){
        l_InactifCpt++;
        if ( l_InactifCpt == DELAY_INACTIVE_TO_SAVE_S ){
            l_InactifCpt++;
            save_config_eeprom ();
            //PORTDbits.RD7 = 0;             TRISDbits.TRISD7 = 0;
        }
    }
    
    if ( 1 == btn_0.u8_Changed){
        btn_0.u8_Changed = 0;
        l_InactifCpt = 0;
    }
    if ( 1 == btn_1.u8_Changed){
        btn_1.u8_Changed = 0;
        l_InactifCpt = 0;
    }
    if ( 1 == btn_2.u8_Changed){
        btn_2.u8_Changed = 0;
        l_InactifCpt = 0;
    }
    if ( 1 == btn_3.u8_Changed){
        btn_3.u8_Changed = 0;
        l_InactifCpt = 0;
    }
        
    
    
    
}

void main(void) {
    
    uint8   l_test_dim = 0;
    
    APP_Clock_init ();
    G_time_ = APP_CLOCK_GET_TIME_MS;
    G_time_ChkBtn = APP_CLOCK_GET_TIME_MS;
    
    dimmer_init ();
    gestion_boutons_init ();
    recall_config_eeprom ();

    
    INTCONbits.TMR0IF = 0;
    INTCONbits.TMR0IE = 1;

    
    //--- INT0 pour le pulse de sync ------------
    INTCON2bits.INTEDG0 = 1;
    INTCONbits.INT0IF = 0;
    INTCONbits.INT0IE = 1;
    INTCONbits.INT0IE = 1;
    INTCONbits.INT0E = 1;
    
    
    HWI_EN_IT;
    
    do{
        
        
        ClrWdt();
        
        // toutes les  50ms
        if ( APP_CLOCK_MES_DELTA_TIME_MS ( G_time_ ) > 5 ){
            G_time_ = APP_CLOCK_GET_TIME_MS;
            gestion_boutons ();
            dimmer_gest_btn ();
        }
        
        //--- toutes les 1s
        if ( APP_CLOCK_MES_DELTA_TIME_MS ( G_time_ChkBtn ) > 100 ){
            G_time_ChkBtn = APP_CLOCK_GET_TIME_MS;
            //PORTDbits.RD7 = 1;             TRISDbits.TRISD7 = 0;
            CheckButonsInactifs ();
        }
  
        
        
        
    }while(1);
    return;
}










